<?php 
//Allows data from the database to be requested
include("assets/ajax/connecti.php");

session_start();

//Formats the document to be an xml and follow xml convention
header( 'Content-type: text/xml' );

//Starts budget tag for all budget data
$_xml = new SimpleXMLElement("<budget/>");

//Get the logged into profile Id from $_SESSION or from $_REQUEST
if( isset( $_REQUEST['profileID'] ) )
{
	$profileID = $_REQUEST['profileID'];
}
else
{
	$profileID = $_SESSION['userSessionValue'];
}


//Used to convert strings from the database to ones specified for the as3 program
$ConvertType = array("withdrawal" => "out", "deposit" => "in", "transfer" => "transfer");

$forecastTable = connecti("CALL get_forecast_data('$profileID',1);");

$partyTable = connecti("CALL get_current_month_transactions('$profileID');");

function chgDate($monthOffset)
{
	return date("m/Y",mktime(0,0,0,date("m") + $monthOffset,1,date("Y")));
}

//Both forecast arrays have indices in the form of a date: mm/yyyy
//The indices go from the current month to 12 months in the future (including the current month)
//Note that date get the current date, and mktime formats that future date


$forecastDate = array(chgDate($i=-1)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0);

$row = mysqli_fetch_array($forecastTable, MYSQLI_ASSOC);
$partyData = mysqli_fetch_array($partyTable, MYSQLI_ASSOC);

$categoryID = '';
$subcategoryID = '';
$type = '';

while($row)
{
	if($categoryID == $row['category_id'] && $type == $row['transaction_type_name'])
	{
		if($subcategoryID == $row['subcategory_id'])
		{
			$subcategory = $category->addChild('subcategory');
			$subcategory->addAttribute("id", $row['subcategory_id']);
			$subcategory->addAttribute("name", $row['subcategory_name']);	
		}
		else
		{
			$subcategory = $category->addChild('subcategory');
			$subcategory->addAttribute("id", $row['subcategory_id']);
			$subcategory->addAttribute("name", $row['subcategory_name']);
			$forecast = $subcategory->addChild('forecast');
		}
	}
	else
	{
		$categoryID = $row['category_id'];
		$type = $row['transaction_type_name'];
		$category = $_xml->addChild('category');
		$category->addAttribute("name", $row['category_name']);
		$category->addAttribute("type", $ConvertType[$type]);
		$subcategory = $category->addChild('subcategory');
		$subcategory->addAttribute("id", $row['subcategory_id']);
		$subcategory->addAttribute("name", $row['subcategory_name']);
		$forecast = $subcategory->addChild('forecast');
	}	
	
	$currentMonthIndex = strtolower(date("M"))."_amount";	

	$date = chgDate(0);
	$value = $forecast->addChild('value');
	$value->addAttribute("forecast_id",$row['forecast_id']);
	$value->addAttribute("month",$date);
	$value->addAttribute("amount",$row[$currentMonthIndex]);
	
	$row = mysqli_fetch_array($forecastTable, MYSQLI_ASSOC);
}

while($partyData)
{
	$result = $_xml->xpath("//subcategory[@id=".$partyData['subcategory_id']."]"); 
	
	$party = $result[0]->addChild('party');
	
	$thirdPartyID = $partyData['third_party_id'];
	
	$party->addAttribute("id",$thirdPartyID);
	$party->addAttribute("name",$partyData['party_name']);
	
	while($thirdPartyID == $partyData['third_party_id'])
	{
		$value = $party->addChild('value');
		$value->addAttribute("month",$partyData['forecast_month']);
		$value->addAttribute("amount",$partyData['amount']);
		$partyData = mysqli_fetch_array($partyTable, MYSQLI_ASSOC);
	}
}

echo (html_entity_decode  ($_xml -> asXML(),ENT_QUOTES  ));
?>