<?php 
//Allows data from the database to be requested
include("assets/ajax/connecti.php");

session_start();

//Formats the document to be an xml and follow xml convention
header('Content-type: text/xml');

//Starts budget tag for all budget data
$_xml = new SimpleXMLElement("<budget/>");

//Get the logged into profile Id from $_SESSION or from $_REQUEST
if( isset( $_REQUEST['profileID'] ) )
{
	$profileID = $_REQUEST['profileID'];
}
else
{
	$profileID = $_SESSION['userSessionValue'];
}


//Used to convert strings from the database to ones specified for the as3 program
$ConvertType = array("withdrawal" => "out", "deposit" => "in", "transfer" => "transfer");

$forecastTable = connecti("CALL get_forecast_data('$profileID',1);");

$partyTable = connecti("CALL get_forecast_party('$profileID');");

function chgDate($monthOffset)
{
	return date("m/Y",mktime(0,0,0,date("m") + $monthOffset,1,date("Y")));
}

//Both forecast arrays have indices in the form of a date: mm/yyyy
//The indices go from the current month to 12 months in the future (including the current month)
//Note that date get the current date, and mktime formats that future date


$forecastDate = array(chgDate($i=0)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0,chgDate(--$i)=>0);

$row = mysqli_fetch_array($forecastTable, MYSQLI_ASSOC);
$partyData = mysqli_fetch_array($partyTable, MYSQLI_ASSOC);

$categoryID = '';
$subcategoryID = '';
$type = '';

while($row)
{
	//Assigns category id
	if($categoryID == $row['category_id'] && $type == $row['transaction_type_name'])
	{
		if($subcategoryID == $row['subcategory_id'])
		{
			$subcategory = $category->addChild('subcategory');
			$subcategory->addAttribute("id", $row['subcategory_id']);
			$subcategory->addAttribute("name", $row['subcategory_name']);	
		}
		else
		{
			$subcategory = $category->addChild('subcategory');
			$subcategory->addAttribute("id", $row['subcategory_id']);
			$subcategory->addAttribute("name", $row['subcategory_name']);
			$forecast = $subcategory->addChild('forecast');
		}
	}
	else
	{
		$categoryID = $row['category_id'];
		$type = $row['transaction_type_name'];
		$category = $_xml->addChild('category');
		$category->addAttribute("name", $row['category_name']);
		$category->addAttribute("type", $ConvertType[$type]);
		$subcategory = $category->addChild('subcategory');
		$subcategory->addAttribute("id", $row['subcategory_id']);
		$subcategory->addAttribute("name", $row['subcategory_name']);
		$forecast = $subcategory->addChild('forecast');
	}	
	
	(date("m") <  1)?($forecastDate["01/".(date("Y")-1)] = $row['jan_amount']):($forecastDate["01/".date("Y")] = $row['jan_amount']);
	(date("m") <  2)?($forecastDate["02/".(date("Y")-1)] = $row['feb_amount']):($forecastDate["02/".date("Y")] = $row['feb_amount']);
	(date("m") <  3)?($forecastDate["03/".(date("Y")-1)] = $row['mar_amount']):($forecastDate["03/".date("Y")] = $row['mar_amount']);
	(date("m") <  4)?($forecastDate["04/".(date("Y")-1)] = $row['apr_amount']):($forecastDate["04/".date("Y")] = $row['apr_amount']);
	(date("m") <  5)?($forecastDate["05/".(date("Y")-1)] = $row['may_amount']):($forecastDate["05/".date("Y")] = $row['may_amount']);
	(date("m") <  6)?($forecastDate["06/".(date("Y")-1)] = $row['jun_amount']):($forecastDate["06/".date("Y")] = $row['jun_amount']);
	(date("m") <  7)?($forecastDate["07/".(date("Y")-1)] = $row['jul_amount']):($forecastDate["07/".date("Y")] = $row['jul_amount']);
	(date("m") <  8)?($forecastDate["08/".(date("Y")-1)] = $row['aug_amount']):($forecastDate["08/".date("Y")] = $row['aug_amount']);
	(date("m") <  9)?($forecastDate["09/".(date("Y")-1)] = $row['sep_amount']):($forecastDate["09/".date("Y")] = $row['sep_amount']);
	(date("m") < 10)?($forecastDate["10/".(date("Y")-1)] = $row['oct_amount']):($forecastDate["10/".date("Y")] = $row['oct_amount']);
	(date("m") < 11)?($forecastDate["11/".(date("Y")-1)] = $row['nov_amount']):($forecastDate["11/".date("Y")] = $row['nov_amount']);
	$forecastDate["12/".(date("Y")-1)] = $row['dec_amount'];
	
	for($i = 0; $i> -12; $i--)
	{
		//Defines the date of the current month to the next year
		$date = chgDate($i);
		$value = $forecast->addChild('value');
		$value->addAttribute("forecast_id",$row['forecast_id']);
		$value->addAttribute("month",$date);
		$value->addAttribute("amount",$forecastDate[$date]);
	}	
	
	$row = mysqli_fetch_array($forecastTable, MYSQLI_ASSOC);
}

while($partyData)
{
	$result = $_xml->xpath("//subcategory[@id=".$partyData['subcategory_id']."]"); 
	
	if(isset($result[0]))
	{
		$party = $result[0]->addChild('party');
		
		$thirdPartyID = $partyData['third_party_id'];
		$party->addAttribute("id", $thirdPartyID);
		$party->addAttribute("name",$partyData['party_name']);
		
		while($thirdPartyID == $partyData['third_party_id'])
		{
			$value = $party->addChild('value');
			$value->addAttribute("month",$partyData['forecast_month']);
			$value->addAttribute("amount",$partyData['amount']);
			$partyData = mysqli_fetch_array($partyTable, MYSQLI_ASSOC);
		}
	}
	else
	{
		$partyData = mysqli_fetch_array($partyTable, MYSQLI_ASSOC);
	}
	
}

echo (html_entity_decode  ($_xml -> asXML(),ENT_QUOTES  ));
?>