<?php
/**
 * PHP Class to user access (login, register, logout, etc)
 * 
 * <code><?php
 * include('access.class.php');
 * $user = new flexibleAccess();
 * ? ></code>
 * 
 * For support issues please refer to the webdigity forums :
 *				http://www.webdigity.com/index.php/board,91.0.html
 * or the official web site:
 *				http://phpUserClass.com/
 * ==============================================================================
 * 
 * @version $Id: access.class.php,v 0.93 2008/05/02 10:54:32 $
 * @copyright Copyright (c) 2007 Nick Papanotas (http://www.webdigity.com)
 * @author Nick Papanotas <nikolas@webdigity.com>
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License (GPL)
 * 
 * ==============================================================================

 */

class flexibleAccess{
  var $dbName = '';
  var $dbTable  = 'user';
  var $sessionVariable = 'userSessionValue';
  var $tbFields = array(
  	'userID'=> 'user_id', 
  	'login' => 'user_name',
  	'pass'  => 'user_password',
  	'email' => 'email',
  	'active'=> 'active'
  );
  var $remTime = 1;//One month
  var $remCookieName = 'ckSavePass';
  var $remCookieDomain = 'greenpigsoftware.com';
  var $passMethod = 'md5';
  var $displayErrors = true;
  var $userID;
  var $dbConn;
  var $userData=array();
  
  function flexibleAccess($dbConn = '', $settings = '', $name = '')
  {
	    if ( is_array($settings) ){
		    foreach ( $settings as $k => $v ){
				    if ( !isset( $this->{$k} ) ) die('Property '.$k.' does not exists. Check your settings.');
				    $this->{$k} = $v;
			}
	    }
	    $this->dbConn = ($dbConn=='')? mysqli_connect($this->dbHost.':'.$this->dbPort, $this->dbUser, $this->dbPass):$dbConn;
	    if ( !$this->dbConn ) die(mysqli_connect_error($this->dbConn));
	    $this->dbName = $name;
	    mysqli_select_db($this->dbConn, $this->dbName)or die(mysqli_connect_error($this->dbConn));
	    if( !isset( $_SESSION ) ) session_start();
	    if ( !empty($_SESSION[$this->sessionVariable]) && !empty($_SESSION['st'])  )
	    {
	    }
  }
  function login($uname, $password, $remember = false, $loadUser = true)
  {
    $uname = $this->escape($uname);
	$uname = strtolower($uname);
	if($uname == "demopig" || $uname == "wagnerpig")
	{
		 mysqli_select_db($this->dbConn, "greenpig_demo")or die(mysqli_connect_error($this->dbConn));
	}	
	else
	{
		mysqli_select_db($this->dbConn, $this->dbName)or die(mysqli_connect_error($this->dbConn));
	}
    	$password = $originalPassword = $this->escape($password);
		switch(strtolower($this->passMethod)){
		  case 'sha1':
		  	$password = "SHA1('$password')"; break;
		  case 'md5' :
		  	$password = "MD5('$password')";break;
		  case 'nothing':
		  	$password = "'$password'";
		}
		$res = mysqli_query($this->dbConn, "call login('".$uname."', ".$password.");");
		$data = mysqli_fetch_array($res, MYSQLI_ASSOC);
		//$res = $this->query("SELECT * FROM user WHERE user_name = '$uname' AND user_password = $password", __LINE__);		
		if ( mysqli_num_rows($res) == 0)
			return false;
		if($data['profile_id'] == null)
			return false;
		if ( $loadUser )
		{
			$_SESSION[$this->sessionVariable] = $data['profile_id'];
			if($uname == "demopig" || $uname == "wagnerpig")
				$_SESSION['st'] = 'd';
			else
				$_SESSION['st'] = "p";
		}
		return true;
  }
  
  function logout($redirectTo = '')
  {
    $_SESSION[$this->sessionVariable] = '';
    $_SESSION['st'] = '';
    $this->userData = '';
    if ( $redirectTo != '' && !headers_sent()){
	   header('Location: /gp/login.php' );
	   exit;//To ensure security
	}
  }

  function is($prop){
  	return $this->get_property($prop)==1?true:false;
  }
  
  function get_property($property)
  {
    if (empty($this->userID)) $this->error('No user is loaded', __LINE__);
    if (!isset($this->userData[$property])) $this->error('Unknown property <b>'.$property.'</b>', __LINE__);
    return $this->userData[$property];
  }
  
  function is_active()
  {
    return $this->userData[$this->tbFields['active']];
  }

  function is_loaded()
  {
    return empty($this->userID) ? false : true;
  }

  function activate()
  {
    if (empty($this->userID)) $this->error('No user is loaded', __LINE__);
    if ( $this->is_active()) $this->error('Already active account', __LINE__);
    $res = $this->query("UPDATE `{$this->dbTable}` SET {$this->tbFields['active']} = 1 
	WHERE `{$this->tbFields['userID']}` = '".$this->escape($this->userID)."' LIMIT 1");
    if (@mysql_affected_rows() == 1)
	{
		$this->userData[$this->tbFields['active']] = true;
		return true;
	}
	return false;
  }

  function insertUser($data){
    if (!is_array($data)) $this->error('Data is not an array', __LINE__);
    switch(strtolower($this->passMethod)){
	  case 'sha1':
	  	$password = "SHA1('".$data[$this->tbFields['pass']]."')"; break;
	  case 'md5' :
	  	$password = "md5('".$data[$this->tbFields['pass']]."')";break;
	  case 'nothing':
	  	$password = $data[$this->tbFields['pass']];
	}
    foreach ($data as $k => $v ) $data[$k] = "'".$this->escape($v)."'";
    $data[$this->tbFields['pass']] = $password;
    $this->query("call add_user(".implode(', ', $data).");");
    return (int)mysql_insert_id($this->dbConn);
  }

  function randomPass($length=10, $chrs = '1234567890qwertyuiopasdfghjklzxcvbnm'){
    for($i = 0; $i < $length; $i++) {
        $pwd .= $chrs{mt_rand(0, strlen($chrs)-1)};
    }
    return $pwd;
  }

  function query($sql, $line = 'Unknown')
  {
	$result = mysqli_query($this->dbConn,$sql);
	if ( !$result)
		$this->error(mysqli_connect_error($this->dbConn).mysqli_error($this->dbConn), $line);
	return $result;
  }

  function loadUser($userID)
  {
	$res = $this->query("SELECT * FROM `{$this->dbTable}` WHERE `{$this->tbFields['userID']}` = '".$this->escape($userID)."' LIMIT 1");
    if ( mysqli_num_rows($res) == 0 )
    	return false;
    $this->userData = mysqli_fetch_array($res, MYSQLI_ASSOC);
    $this->userID = $userID;
    $_SESSION[$this->sessionVariable] = $this->userID;
    return true;
  }

  function escape($str) {
    $str = get_magic_quotes_gpc()?stripslashes($str):$str;
    $str = mysqli_real_escape_string($this->dbConn, $str);
    return $str;
  }

  function error($error, $line = '', $die = false) {
    if ( $this->displayErrors )
    	echo '<b>Error: </b>'.$error.'<br /><b>Line: </b>'.($line==''?'Unknown':$line).'<br />';
    if ($die) exit;
    return false;
  }
}
?>