
/**
 * Shows a tooltip MESSAGE on the OBJECT after .5 seconds.
 * The message can be moved by using left and top parameters.
 * 
 * @param	OBJECT	jquery object from, include . or # and class or id
 * @param	MESSAGE	the tooltip message
 * @param	left	displacement relative to the object left/right
 * @param	top		displacement relative to the object up/down
 */
function tooltip(OBJECT, MESSAGE,left,top)
{
	$(OBJECT).hover(
	//if mouse is hovering over
	function () 
	{
		//Adds timeout for .5 seconds
		var t = setTimeout(function() {
			//Adds tooltip to the body
			$("<div id=\"tooltip\"></div>").appendTo("body");
			var TIP = $("#tooltip"); //Assigns tip object to TIP
			var position = $(OBJECT).position(); //gets the OBJECT's position
			
			//Spans message into the TIP div
			TIP.append( $("<span>"+ MESSAGE +"</span>") );
			
			//Removes the previous style attribute
			TIP.removeAttr("style");
			
			//If OBJECT is on the bottom black bar
			if(OBJECT.match(/^#square/)!=null)
			{
				//Sets the TIP div css position:fixed; left: OBJECTS left + offset; bottom: OBJECTS height
				TIP.css("position","fixed");
				TIP.css("left",position.left + left);
				TIP.css("bottom",50);
			}
			//If OBJECT is not on the bottom black bar
			else
			{		
				//Sets the TIP div css position:absolute; left: OBJECTS left + offset; top: OBJECTS top + offset;
				TIP.css("position","absolute");
				TIP.css("left",position.left + left);
				TIP.css("top",position.top - TIP.height() + top);
			}
		},500);
		$(this).data('timeout', t);
	}, 
	//if mouse is not hovering over
	function () 
	{
		//Removes the timeout
		clearTimeout($(this).data('timeout'));
		$("#tooltip").remove();
	}
	);
}