<?php 
//Allows data from the database to be requested
include("../ajax/connecti.php");
date_default_timezone_set('America/Chicago');
session_start();

//Formats the document to be an xml and follow xml convention
header( 'Content-type: text/xml' );

//Starts budget tag for all budget data
$_xml = new SimpleXMLElement("<budget/>");

//Get the logged into profile Id from $_SESSION or from $_REQUEST
if( isset( $_REQUEST['profileID'] ) )
{
	$profileID = $_REQUEST['profileID'];
}
else
{
	$profileID = $_SESSION['userSessionValue'];
}

//0 is Future Data and 1 is Past Data.
$isPast = $_REQUEST['isPast'];

//Used to convert strings from the database to ones specified for the as3 program
$ConvertType = array("withdrawal" => "out", "deposit" => "in", "transfer" => "transfer");

//Array that holds the month amounts
$dateArray = array("", "jan_amount", "feb_amount", "mar_amount", "apr_amount","may_amount", "jun_amount","jul_amount", "aug_amount","sep_amount", "oct_amount","nov_amount", "dec_amount");


//Get all past forecast data
//CALL greenpig_dev.get_forecast_data('fade0ac0-55c9-102d-95c4-0002b306ff19', 1)
//$forecastTablePast = connecti("CALL get_forecast_data('$profileID',1);");

//Get all future forecast data
//CALL greenpig_dev.get_forecast_data('fade0ac0-55c9-102d-95c4-0002b306ff19', 0)
//$forecastTableFuture = connecti("CALL get_forecast_data('$profileID',0);");

//Oddity, commented out line does not work but line below it does...
//$forecastTableFuture = connecti("CALL get_forecast_data('$profileID','$isPast');");
//$forecastTableFuture = connecti("CALL get_forecast_data('$profileID',".$isPast.");");

$forecastTable = connecti("CALL get_forecast_data('$profileID',".$isPast.");");

$categoryID = '';
$subcategoryID = '';
$type = '';

while($forecastTableRow = mysqli_fetch_array($forecastTable, MYSQLI_ASSOC))
{
	if($categoryID != $forecastTableRow['category_id'] || $type != $forecastTableRow['transaction_type_name'])
	{
		$categoryID = $forecastTableRow['category_id'];
		$type = $forecastTableRow['transaction_type_name'];
		$category = $_xml->addChild('category');
		$category->addChild("categoryname", rawurlencode($forecastTableRow['category_name']));
		$category->addChild("categoryid", $categoryID);
		$category->addChild("type", $ConvertType[$type]);
	}
	
	$subcategory = $category->addChild('subcategory');
	$subcategory->addChild("subcategoryid", $forecastTableRow['subcategory_id']);
	$subcategory->addChild("subcategoryname", rawurlencode($forecastTableRow['subcategory_name']));	
	
	for($i = 0; $i < 12; ++$i)
	{
		if($isPast == 0)
		{
			$date = mktime(0,0,0,date("m") + $i,1, date("Y"));
			$forecastid = (date("Y",$date) == date("Y")) ? 'past_forecast_id' : 'newest_forecast_id';
		}
		else if($isPast == 1)
		{
			$date = mktime(0,0,0,date("m") - $i,1, date("Y"));
			$forecastid = 'forecast_id';
		}
		
		$forecast = $subcategory->addChild('forecast');
		$forecast->addChild("forecastid",$forecastTableRow[$forecastid]);
		$forecast->addChild("month",date("m/Y", $date));
		
		//Note: changed "m" to "n" for efficiency (Month with leading-zero vs. Month without leading-zero)
		$temp = date("n", $date);
		
		if($forecastTableRow[$dateArray[$temp]] != "")
			$forecast->addChild("amount",$forecastTableRow[$dateArray[$temp]]);
		else
			$forecast->addChild("amount", "null");
	}
}

//Get all past party data
//Goes with $forecastTablePast 
//CALL get_forecast_party('fade0ac0-55c9-102d-95c4-0002b306ff19')
if($isPast == 1)
{
	$partyTable = connecti("CALL get_forecast_party('$profileID');");
	$partyTableRow = mysqli_fetch_array($partyTable, MYSQLI_ASSOC);
	
	while($partyTableRow)
	{
		$result = $_xml->xpath("//subcategory[subcategoryid=".$partyTableRow['subcategory_id']."]"); 
		
		if(isset($result[0]))
			$party = $result[0]->addChild('party');
		
		$thirdPartyID = $partyTableRow['third_party_id'];
		$subcategoryID = $partyTableRow['subcategory_id'];
	
		$party->addChild("partyid",$thirdPartyID);
		$party->addChild("partyname",rawurlencode($partyTableRow['party_name']));
		
		while($thirdPartyID == $partyTableRow['third_party_id'] && $subcategoryID == $partyTableRow['subcategory_id'])
		{
			$transaction = $party->addChild('transaction');
			$transaction->addChild("month",$partyTableRow['forecast_month']);
			$transaction->addChild("amount",$partyTableRow['amount']);
			$partyTableRow = mysqli_fetch_array($partyTable, MYSQLI_ASSOC);
		}
	}
}

echo (html_entity_decode  ($_xml -> asXML(),ENT_QUOTES  ));
?>