<?php
session_start();
include('assets/ajax/connecti.php');
// process the email
if (array_key_exists('send', $_POST)) {
	$to = 'biermic@gmail.com';
	$subject = 'Green Pig Software';
	
	//list expected fields
	$expected = array('name', 'email', 'comments');
	// set required fields
	$required = array('name', 'email', 'comments');
	// create empty array for any missing fields
	$missing = array();
	
	// assume that there is nothing suspect
	$suspect = false;
	// create a pattern to locate suspect phrases
	$pattern = '/Content-Type:|Bcc:|Cc:/i';
	
	// function to check for suspect phrases
	function isSuspect($val, $pattern, &$suspect) {
	// if the variable is an array, loop through each element
	// and pass it recursively back to the same function
	if (is_array($val)) {
		foreach ($val as $item) {
			isSuspect($item, $pattern, $suspect);
			}
		}
	else {
		// if one of the suspect phrases is found, set Boolean to true
		if (preg_match($pattern, $val)) {
			$suspect = true;
			}
		}
	}
	
	// check the $_POST array and any subarrays for suspect content
	isSuspect($_POST, $pattern, $suspect);
	
	if ($suspect) {
		$mailSent = false;
		unset($missing);
		}
	else {
		// process the $_POST variables
		foreach ($_POST as $key => $value) {
			// assign to temporary variable and strip whitespace if not an array
			$temp = is_array($value) ? $value : trim($value);
			// if empty and required, add to $missing array
			if (empty($temp) && in_array($key, $required)) {
				array_push($missing, $key);
				}
			// otherwise, assign to a variable of the same name as $key
			elseif (in_array($key, $expected)) {
				${$key} = $temp;
				}
			}
		}

// validate the email address
if (!empty($email)) {
	// regex to ensure no illegal characters in email address
	$checkEmail = '/^[^@]+@[^\s\r\n\'";,@%]+$/';
	// reject the email adddress if it doesn't match
	if (!preg_match($checkEmail, $email)) {
		array_push($missing, 'email');
		}
	}
			
// go ahead only if not suspect and all required fields OK
if (!$suspect && empty($missing)) {
	// build the message
	$message = "Name: $name\n\n";
	$message .= "Email: $email\n\n";
	$message .= "Comments: $comments";
	
	// limit the line length to 70 characters
	$message = wordwrap($message, 500);
	
	// create additional headers
	$additionalHeaders = 'From: Green Pig Software<support@greenpigsoftware.org>';
	$additionalHeaders .= "\r\nReply-To: $email";
	
	// send it
	$mailSent = mail($to, $subject, $message, $additionalHeaders);
	if ($mailSent) {
		// $missing is no longer needed if the email is sent, so unset it
		unset($missing);
		}
	}	
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>Green Pig Software - Contact Us</title>
<script language="javascript" type="text/javascript" src="assets/js/jquery.js"></script>
<link href="assets/css/stylesheet.css" rel="stylesheet" media="all" type="text/css" />
<link type="text/css" href="assets/css/modals.css" rel="Stylesheet" />	
</head>

<body>
<div id="modalBG" ></div>
<div id="loading"><img src="assets/images/ajax-loader.gif"/><BR/><BR/><BR/>Loading...</div>
<?php include('header.php');
	  include('jsonObjects.php');
      include('editProfile.php');?>
<script language="javascript" type="text/javascript">$('#personalbusiness').hide();</script>
<div style="width: 400px; margin-left: auto; margin-right: auto;color: black">
<br /><br />
<h1 style="color:green">Contact Us</h1>
<br />
<?php
if ($_POST && isset($missing) && !empty($missing)) {
?>
<p class="warning">Please complete the missing item(s) indicated.</p>
<?php
	}
elseif ($_POST && !$mailSent) {
//display a failure message
?>
<p class ="warning">Sorry, there was a problem sending your message.  Please try again.</p>
<?php
	}
elseif ($_POST && $mailSent) {
// display an acknowledgment
?>
<p><strong>Your message has been sent.  Thank you for your feedback.</strong></p>
<?php } ?>
<form id="feedback" method="post" action="">
	<p>
		<label for="name">Name: <?php if (isset($missing) && in_array('name', $missing)) { ?><span class="warning">Please enter your name</span><?php } ?></label><br />
		<input name="name" id="name" type="text" class="formbox" <?php if (isset($missing)) { echo 'value="'.htmlentities($_POST['name']).'"'; } ?>
		/>
	</p>
	<p>
		<label for="email">Email: <?php
		if (isset($missing) && in_array('email', $missing)) { ?>
		<span class="warning">Please enter your email address</span><?php } ?>
		</label><br />
		<input name="email" id="email" type="text" class="formbox" 
		<?php if (isset($missing)) {
			echo 'value="'.htmlentities($_POST['email']).'"';
			} ?>
		/>
	</p>
	<p>
		<label for="comments">Comments: <?php
		if (isset($missing) && in_array('comments', $missing)) { ?>
		<span class="warning">Please enter your comments</span><?php } ?>
		</label><br />
		<textarea name="comments" id="comments" cols="60" rows="8"><?php
		 if (isset($missing)) {
			echo htmlentities($_POST['comments']);
			} ?></textarea>
	</p>
	<p>
		<input name="send" id="send" type="submit" value="Send Message" />
	</p>
    <p>
    <br /><br />Dr. Gerald Wagner<br /> 
    2212 South 64th Plaza
<br />
Suite 317<br /> 
Omaha, Nebraska 68106
<br />
Email: <a style="color:green" href="mailto:wagnergeraldr@gmail.com">wagnergeraldr@gmail.com</a><br />

    </p>
</form>
</div>
</body>
</html>