<?php
/**
 * @file
 *    Defines the hello_world widget.
 *
 * Released under the GNU General Public License.  See LICENSE.txt.
 */

// The get widget handler.
function widget_hello_world() {
  // A widget object as per jquery.dashboard.js.
  return array(
    'title' => 'Hello World',
    'content' => '<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore <strong>magna aliqua</strong>. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p>',
    'initScript' => 'widgets/scripts/init.js',
    'classes' => 'social',
    'settings' => true,
    'fullscreen' => '<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. <em>Excepteur sint</em> occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p>',
    'fullscreenScript' => 'widgets/scripts/fullscreen.js',
    'fullscreenInitScript' => 'widgets/scripts/initFullscreen.js',
  );
}

// The widget settings handler.
function widget_hello_world_settings() {
  // Useful to test what happens if the user clicks in and out of settings-edit mode before settings have finished initializing.
  // sleep(5);

  // Save &/or load user's settings here!
  if ($GLOBALS['_POST']['settings']) {
    $data = $GLOBALS['_POST']['settings'];
  }
  else {
    $data = array(
      'color' => 'red',
      'title' => 'Mello Yellow',
    );
  }

  // A widget settings object as per jquery.dashboard.js.
  return array(
    'markup' => '<div>' . ($GLOBALS['_POST']['settings'] ? 'Reloaded Title' : 'Title') . '</div>
                 <div><input name="title" type="text" value="' . $data['title'] . '" /></div>
                 <div><select name="color">
                   <option' . selected($data, 'yellow') . '>Yellow</option>
                   <option' . selected($data, 'red') . '>Red</option>
                   <option' . selected($data, 'blue') . '>Blue</option>
                 </select></div>
                 <div><label><input name="on" type="checkbox" value="1" ' . ($data['on'] ? 'checked="checked"' : '') . ' />Feature on</label></div>',
  );
}

// A silly little helper function for the form.
function selected($data, $color) {
  if ($data['color'] == $color) {
    return ' value="' . $color . '" selected="selected"';
  }
  else {
    return ' value="' . $color . '"';
  }
}
